package xyz.lychee.lagfixer.libs.adventure.util;

import xyz.lychee.lagfixer.libs.adventure.builder.AbstractBuilder;
import xyz.lychee.lagfixer.libs.annotations.CheckReturnValue;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public interface InheritanceAwareMap<C, V> {
   static <K, E> @NotNull InheritanceAwareMap<K, E> empty() {
      return InheritanceAwareMapImpl.EMPTY;
   }

   static <K, E> @NotNull Builder<K, E> builder() {
      return new InheritanceAwareMapImpl.BuilderImpl();
   }

   static <K, E> @NotNull Builder<K, E> builder(final InheritanceAwareMap<? extends K, ? extends E> existing) {
      return (new InheritanceAwareMapImpl.BuilderImpl()).putAll(existing);
   }

   boolean containsKey(final @NotNull Class<? extends C> clazz);

   @Nullable V get(final @NotNull Class<? extends C> clazz);

   @CheckReturnValue
   @NotNull InheritanceAwareMap<C, V> with(final @NotNull Class<? extends C> clazz, final @NotNull V value);

   @CheckReturnValue
   @NotNull InheritanceAwareMap<C, V> without(final @NotNull Class<? extends C> clazz);

   public interface Builder<C, V> extends AbstractBuilder<InheritanceAwareMap<C, V>> {
      @NotNull
      @NotNull Builder<C, V> strict(final boolean strict);

      @NotNull
      @NotNull Builder<C, V> put(final @NotNull Class<? extends C> clazz, final @NotNull V value);

      @NotNull
      @NotNull Builder<C, V> remove(final @NotNull Class<? extends C> clazz);

      @NotNull
      @NotNull Builder<C, V> putAll(final @NotNull InheritanceAwareMap<? extends C, ? extends V> map);
   }
}
